﻿/*
@@@BUILDINFO@@@ Export Layers To BeatFlyer.jsx 1.0.0.0
*/

/*
// BEGIN__HARVEST_EXCEPTION_ZSTRING

<javascriptresource>

<name>$$$/JavaScripts/ExportLayersToBeatFlyer/Menu=Layers to BeatFlyer</name>

    <category>scriptexport</category>

    <menu>export</menu>

    

<enableinfo>true</enableinfo>

<eventid>e37e675a-3b3d-4c0a-9363-22f03016d989</eventid>

</javascriptresource>

// END__HARVEST_EXCEPTION_ZSTRING
*/


// enable double clicking from the 
// Macintosh Finder or the Windows Explorer
#target photoshop

// Make Photoshop the frontmost application
app.bringToFront();

// debug level: 0-2 (0:disable, 1:break on error, 2:break at beginning)
$.level = 1;
$.writeln('Running export layers to BeatFlyer...');
var docRef = app.activeDocument;
$.writeln('name: ' + docRef.name);
if( docRef.name.split('.').pop().toLowerCase() !== 'psd' ){
    alert('please save your document before exporting');
}else{
    var documentPath = docRef.path;
    $.writeln('Will export layers in: ' + documentPath); // TODO: handles unsaved documents, I guess ask where to save them in case.
    var filename = docRef.name.split('.')[0];
    exportInPath( documentPath + '/' + filename + '__' );
}

function exportInPath ( path ){
    
    var visiblelayers = [];
    for( var i=0; i<docRef.layers.length; i++){
        var layer = docRef.layers[i];
        if( layer.visible ) {
            visiblelayers.unshift( layer );
        }
    }

    $.writeln('Will export ' + visiblelayers.length + ' layers...');

    // hide all visible layers
    for( var i=0; i<visiblelayers.length; i++){
        var layer = visiblelayers[i];
        layer.visible = false;
    }

    // save each layer
    for( var i=0; i<visiblelayers.length; i++){
        var layer = visiblelayers[i];
        layer.visible = true;
        saveWithName( path + 'layer_' + i + '.png');
        layer.visible = false;
    }

    // show again all visible layers
    for( var i=0; i<visiblelayers.length; i++){
        var layer = visiblelayers[i];
        layer.visible = true;
    }

    $.writeln('Layers exported.');
}
    

function saveWithName( fileName ){
    $.writeln('Will save layer: ' + fileName);
    var topAd = new ActionDescriptor();
    var ad = new ActionDescriptor();
    ad.putEnumerated( charIDToTypeID( "Op  " ), charIDToTypeID( "SWOp" ), charIDToTypeID( "OpSa" ) );
    ad.putEnumerated( charIDToTypeID( "Fmt " ), charIDToTypeID( "IRFm" ), charIDToTypeID( "PN24" ) );
    ad.putBoolean( charIDToTypeID( "Intr" ), false );
    ad.putBoolean( charIDToTypeID( "Trns" ), true );
    ad.putBoolean( charIDToTypeID( "Mtt " ), true );
    ad.putInteger( charIDToTypeID( "MttR" ), 255 );
    ad.putInteger( charIDToTypeID( "MttG" ), 255 );
    ad.putInteger( charIDToTypeID( "MttB" ), 255 );
    ad.putBoolean( charIDToTypeID( "SHTM" ), false );
    ad.putBoolean( charIDToTypeID( "SImg" ), true );
    ad.putBoolean( charIDToTypeID( "SSSO" ), false );
    ad.putList( charIDToTypeID( "SSLt" ), new ActionList() );
    ad.putBoolean( charIDToTypeID( "DIDr" ), false );
    ad.putPath( charIDToTypeID( "In  " ), new File( fileName ) );
    ad.putBoolean( charIDToTypeID( "EICC" ), false );
    topAd.putObject( charIDToTypeID( "Usng" ), stringIDToTypeID( "SaveForWeb" ), ad);
    executeAction( charIDToTypeID( "Expr" ), topAd, DialogModes.NO );
    $.writeln('saved layer: ' + fileName);
}